From 955ede7ea86d7d3ffaf390b78406578f1244520f Mon Sep 17 00:00:00 2001
From: Konstantin Oblaukhov <oblaukhov.konstantin@gmail.com>
Date: Wed, 15 Mar 2023 17:19:02 +0700
Subject: [PATCH 05/13] Genlock for FD922.

---
 forward-v4l2/forward-v4l2-fd722.c   |   6 +-
 forward-v4l2/forward-v4l2-fd788.c   |   6 +-
 forward-v4l2/forward-v4l2-fd922.c   | 215 ++++++++++
 forward-v4l2/forward-v4l2-genlock.c |   3 +-
 forward/forward-fd922.c             |   7 -
 forward/forward-si532x.c            |  11 +-
 forward/forward-si534x.c            | 605 +++++++++++++++++++++-------
 include/forward-pll.h               |   4 +-
 8 files changed, 685 insertions(+), 172 deletions(-)

diff --git a/forward-v4l2/forward-v4l2-fd722.c b/forward-v4l2/forward-v4l2-fd722.c
index 4f1b5b2..d5f1809 100644
--- a/forward-v4l2/forward-v4l2-fd722.c
+++ b/forward-v4l2/forward-v4l2-fd722.c
@@ -85,7 +85,7 @@ static void fd722_check_pll_configuration(struct forward_v4l2 *v4l2)
 
 	if ((clk_m != any_m) || !clk_valid) {
 		struct forward_pll_mode *mode;
-		mode = pll->ops->find_mode(pll, 0, 0, 148500000, any_m);
+		mode = pll->ops->find_mode(pll, 0, 0, any_m, 148500000, any_m);
 
 		if (!mode)
 			return;
@@ -731,7 +731,7 @@ static int fd722_genlock_switch(const struct forward_v4l2_genlock *gl,
 	struct forward_pll_mode *mode = NULL;
 
 	if (src == V4L_FORWARD_GENLOCK_SRC_MASTER) {
-		mode = pll->ops->find_mode(pll, 0, 0, 148500000, false);
+		mode = pll->ops->find_mode(pll, 0, 0, false, 148500000, false);
 		pll->ops->switch_mode(pll, mode);
 		pll->ops->select_input(pll, 1, false, false);
 		pll->ops->calibrate(pll);
@@ -754,7 +754,7 @@ static int fd722_genlock_switch(const struct forward_v4l2_genlock *gl,
 			gl.mode = (src == V4L_FORWARD_GENLOCK_SRC_IN1) ? 3 : 2;
 		}
 
-		mode = pll->ops->find_mode(pll, pll_in_freq, 0, 148500000, t->sdi.m);
+		mode = pll->ops->find_mode(pll, pll_in_freq, 0, t->sdi.m, 148500000, t->sdi.m);
 		if (!mode)
 			return -EINVAL;
 
diff --git a/forward-v4l2/forward-v4l2-fd788.c b/forward-v4l2/forward-v4l2-fd788.c
index 6f5725e..d86b292 100644
--- a/forward-v4l2/forward-v4l2-fd788.c
+++ b/forward-v4l2/forward-v4l2-fd788.c
@@ -91,7 +91,7 @@ static void fd788_check_pll_configuration(struct forward_v4l2 *v4l2)
 
 	if ((clk_m != any_m) || !clk_valid) {
 		struct forward_pll_mode *mode;
-		mode = pll->ops->find_mode(pll, 0, 0, 148500000, any_m);
+		mode = pll->ops->find_mode(pll, 0, 0, any_m, 148500000, any_m);
 
 		if (!mode)
 			return;
@@ -914,7 +914,7 @@ static int fd788_genlock_switch(const struct forward_v4l2_genlock *gl,
 	struct forward_pll_mode *mode = NULL;
 
 	if (src == V4L_FORWARD_GENLOCK_SRC_MASTER) {
-		mode = pll->ops->find_mode(pll, 0, 0, 148500000, false);
+		mode = pll->ops->find_mode(pll, 0, 0, false, 148500000, false);
 		pll->ops->switch_mode(pll, mode);
 		pll->ops->select_input(pll, 1, false, false);
 		pll->ops->calibrate(pll);
@@ -937,7 +937,7 @@ static int fd788_genlock_switch(const struct forward_v4l2_genlock *gl,
 			gl.mode = (src == V4L_FORWARD_GENLOCK_SRC_IN1) ? 3 : 2;
 		}
 
-		mode = pll->ops->find_mode(pll, pll_in_freq, 0, 148500000, t->sdi.m);
+		mode = pll->ops->find_mode(pll, pll_in_freq, 0, t->sdi.m, 148500000, t->sdi.m);
 		if (!mode)
 			return -EINVAL;
 
diff --git a/forward-v4l2/forward-v4l2-fd922.c b/forward-v4l2/forward-v4l2-fd922.c
index 56b7621..937a738 100644
--- a/forward-v4l2/forward-v4l2-fd922.c
+++ b/forward-v4l2/forward-v4l2-fd922.c
@@ -25,6 +25,8 @@
 #include "forward-v4l2-ioctl.h"
 #include "forward-pll.h"
 
+#include "forward-v4l2-genlock.h"
+
 #include "fd922_reg.h"
 
 #define FD922_BUFFER_NUMBER(in, irq) (((irq) >> ((in)*3 + 1)) & 0x3)
@@ -32,6 +34,12 @@
 #define FD922_NUMBER_IN_BUFFERS (4)
 #define FD922_NUMBER_OUT_BUFFERS (2)
 
+#define FD922_GENLOCK_ANALOG_DELAY 300
+#define FD922_GENLOCK_SD_NTSC_DELAY 27953
+#define FD922_GENLOCK_SD_PAL_DELAY 364
+#define FD922_GENLOCK_HD_DELAY 189
+#define FD922_GENLOCK_3G_DELAY 97
+
 // 50 buffers per second at 270 Mbit/s
 #define FD922_ASI_IN_BUFFER_SIZE (270000000ULL / 10 / 50)
 #define FD922_ASI_IN_BUFFER_SIZE_RAW (270000000ULL / 8 / 50)
@@ -630,6 +638,206 @@ static s64 fd922_set_clock_deviation(struct forward_v4l2 *v4l2, s64 ppt)
 	return v4l2->dev->pll->ops->tune(v4l2->dev->pll, ppt);
 }
 
+static int fd922_genlock_query(const struct forward_v4l2_genlock *gl,
+			       enum v4l2_forward_genlock_source src, struct forward_v4l2_timings *t)
+{
+	struct forward_v4l2 *v4l2 = gl->v4l2;
+
+	if (src == V4L_FORWARD_GENLOCK_SRC_MASTER) {
+		*t = v4l2->io[2].timings;
+		return 0;
+	} else if (src == V4L_FORWARD_GENLOCK_SRC_IN0)
+		return fd922_timings_query(&v4l2->io[0], t);
+	else if (src == V4L_FORWARD_GENLOCK_SRC_IN1)
+		return fd922_timings_query(&v4l2->io[1], t);
+	else if (src == V4L_FORWARD_GENLOCK_SRC_ANALOG) {
+		FD922_AnalogSync cnt = FD922_AnalogSync_R(v4l2->dev->csr);
+
+		if ((cnt.hsync > 2048) || (cnt.vsync > 1000000) || (cnt.hsync == 0) ||
+		    (cnt.vsync == 0))
+			return -ENOLINK;
+
+		return forward_v4l2_timing_guess_analog(18000000 / cnt.hsync,
+							18000000000 / cnt.vsync, t) ?
+			       0 :
+			       -ERANGE;
+	} else
+		return -EINVAL;
+}
+
+static int fd922_genlock_switch(const struct forward_v4l2_genlock *gl,
+				enum v4l2_forward_genlock_source src,
+				struct forward_v4l2_timings *t)
+{
+	struct forward_v4l2 *v4l2 = gl->v4l2;
+	struct forward_pll *pll = v4l2->dev->pll;
+	FD922_SyncGenerator sg = { 0 };
+	FD922_SyncGeneratorField sgf = { 0 };
+	struct forward_pll_mode *mode = NULL;
+
+	if (src == V4L_FORWARD_GENLOCK_SRC_MASTER) {
+		mode = pll->ops->find_mode(pll, 0, 0, false, 148500000, false);
+		pll->ops->switch_mode(pll, mode);
+		pll->ops->select_input(pll, 0, true, false);
+		pll->ops->calibrate(pll);
+	} else {
+		unsigned int pll_pix_freq = 0;
+		unsigned int pll_h_freq = 0;
+		int pll_input = 0;
+
+		FD922_Genlock gl = FD922_Genlock_R(v4l2->dev->csr);
+
+		pll_pix_freq = forward_v4l2_pixel_clock(t);
+		pll_h_freq = pll_pix_freq / t->sdi.width;
+		if (t->sdi.mode == FORWARD_SDI_MODE_6G_SDI) {
+			pll_pix_freq /= 2;
+			pll_h_freq /= 2;
+		} else if (t->sdi.mode == FORWARD_SDI_MODE_12G_SDI) {
+			pll_pix_freq /= 4;
+			pll_h_freq /= 2;
+		}
+		if (src == V4L_FORWARD_GENLOCK_SRC_ANALOG) {
+			pll_input = 0;
+			gl.mode = (t->sdi.mode == FORWARD_SDI_MODE_SD_SDI) ? 1 : 0;
+		} else {
+			pll_input = (src == V4L_FORWARD_GENLOCK_SRC_IN0) ? 1 : 2;
+			gl.mode = (src == V4L_FORWARD_GENLOCK_SRC_IN0) ? 2 : 3;
+		}
+
+		gl.m = t->sdi.m ? true : false;
+
+		mode = pll->ops->find_mode(pll, pll_pix_freq, pll_h_freq, t->sdi.m, 148500000,
+					   false);
+		if (!mode)
+			return -EINVAL;
+
+		FD922_Genlock_W(v4l2->dev->csr, gl);
+		pll->ops->switch_mode(pll, mode);
+
+		pll->ops->select_input(pll, pll_input, false, false);
+		pll->ops->calibrate(pll);
+	}
+
+	sg.frameSize = t->sdi.width * t->sdi.height;
+	if (t->sdi.mode == FORWARD_SDI_MODE_SD_SDI)
+		sg.frameSize *= 11;
+	else if (t->sdi.mode == FORWARD_SDI_MODE_HD_SDI)
+		sg.frameSize *= 2;
+	if (t->sdi.interlaced)
+		sgf.fieldSize = sg.frameSize / 2;
+	else
+		sgf.fieldSize = sg.frameSize;
+
+	if (!sg.frameSize || !sgf.fieldSize) {
+		sg.frameSize = 5940000;
+		sgf.fieldSize = 2970000;
+	}
+	sg.m = t->sdi.m ? 1 : 0;
+
+	FD922_SyncGenerator_W(v4l2->dev->csr, 0, sg);
+	FD922_SyncGeneratorField_W(v4l2->dev->csr, 0, sgf);
+
+	return 0;
+}
+
+u32 fd922_genlock_sync_irq_mask(const struct forward_v4l2_genlock *gl, int num)
+{
+	return num ? (1 << 14) : (1 << 12);
+}
+
+bool fd922_genlock_sync_irq_info(const struct forward_v4l2_genlock *gl, int num, u32 irq,
+				 bool *field, s32 *gl_offset)
+{
+	struct forward_v4l2 *v4l2 = gl->v4l2;
+	u32 ref_time = 0, sync_time;
+
+	if (!(irq & (num ? (1 << 14) : (1 << 12))))
+		return false;
+
+	*field = (irq & (num ? (1 << 15) : (1 << 13))) ? true : false;
+	sync_time = FD922_SyncGeneratorTime_R(v4l2->dev->csr, num).time;
+
+	if (gl->source == V4L_FORWARD_GENLOCK_SRC_IN0)
+		ref_time = FD922_VideoInIRQRefTime_R(v4l2->dev->csr, 0).time;
+	else if (gl->source == V4L_FORWARD_GENLOCK_SRC_IN1)
+		ref_time = FD922_VideoInIRQRefTime_R(v4l2->dev->csr, 1).time;
+	else if (gl->source == V4L_FORWARD_GENLOCK_SRC_ANALOG)
+		ref_time = FD922_AnalogVSyncTime_R(v4l2->dev->csr).time;
+
+	*gl_offset = (s32)(sync_time - ref_time);
+
+	return true;
+}
+
+void fd922_genlock_sync_offset(const struct forward_v4l2_genlock *gl, int num, s32 offset,
+			       bool comp_delay)
+{
+	s32 frame_size = gl->timings.sdi.height * gl->timings.sdi.width;
+	FD922_SyncGeneratorPhase ph;
+	s32 sync_gen_offset = 0;
+
+	if (gl->source == V4L_FORWARD_GENLOCK_SRC_ANALOG) {
+		if (gl->timings.sdi.height == 1125)
+			sync_gen_offset =
+				-(gl->timings.sdi.width - gl->timings.sdi.active_width - 192);
+		else if (gl->timings.sdi.height == 750)
+			sync_gen_offset =
+				-(gl->timings.sdi.width - gl->timings.sdi.active_width - 260);
+		else if (gl->timings.sdi.height == 625)
+			sync_gen_offset = -12 - 46;
+		else if (gl->timings.sdi.height == 525)
+			sync_gen_offset = -16 - 44;
+
+		sync_gen_offset += -gl->timings.sdi.width;
+		if (!gl->timings.sdi.interlaced)
+			sync_gen_offset += -gl->timings.sdi.width;
+	}
+
+	if (gl->timings.sdi.mode == FORWARD_SDI_MODE_SD_SDI) {
+		frame_size *= 11;
+		sync_gen_offset *= 11;
+	} else if (gl->timings.sdi.mode == FORWARD_SDI_MODE_HD_SDI) {
+		frame_size *= 2;
+		sync_gen_offset *= 2;
+	}
+
+	if (gl->source == V4L_FORWARD_GENLOCK_SRC_ANALOG)
+		sync_gen_offset += -FD922_GENLOCK_ANALOG_DELAY;
+	else {
+		if (gl->timings.sdi.mode == FORWARD_SDI_MODE_SD_SDI)
+			sync_gen_offset += (gl->timings.sdi.height == 525) ?
+						   -FD922_GENLOCK_SD_NTSC_DELAY :
+						   -FD922_GENLOCK_SD_PAL_DELAY;
+		else if (gl->timings.sdi.mode == FORWARD_SDI_MODE_HD_SDI)
+			sync_gen_offset += -FD922_GENLOCK_HD_DELAY;
+		else
+			sync_gen_offset += -FD922_GENLOCK_3G_DELAY;
+	}
+
+	if (!comp_delay)
+		sync_gen_offset = 0;
+
+	offset += sync_gen_offset;
+
+	if (offset > frame_size)
+		offset = offset % frame_size;
+	if (offset < 0)
+		offset = (offset % frame_size) + frame_size;
+
+	ph.phase = offset;
+	FD922_SyncGeneratorPhase_W(gl->v4l2->dev->csr, num, ph);
+}
+
+void fd922_genlock_sync_output(const struct forward_v4l2_genlock *gl, struct forward_v4l2_io *io)
+{
+	FD922_VideoOutCS cs = FD922_VideoOutCS_R(io->v4l2->dev->csr, (io->index - 2));
+	bool correct = forward_v4l2_timings_fps_divisible(&gl->timings, &io->timings);
+	cs.freeRunning = (io->genlock && correct) ? 0 : 1;
+	cs.syncSource = io->genlock_sync_gen;
+	cs.clockM = gl->timings.sdi.m ? 1 : 0;
+	FD922_VideoOutCS_W(io->v4l2->dev->csr, (io->index - 2), cs);
+}
+
 struct forward_v4l2_dev_ops fd922_ops = {
 	.irq_mask = fd922_irq_mask,
 	.irq_info = fd922_irq_info,
@@ -653,4 +861,11 @@ struct forward_v4l2_dev_ops fd922_ops = {
 	.hw_timestamp = fd922_hw_timestamp,
 	.clock_deviation = fd922_clock_deviation,
 	.set_clock_deviation = fd922_set_clock_deviation,
+
+	.genlock_query = fd922_genlock_query,
+	.genlock_switch = fd922_genlock_switch,
+	.genlock_sync_irq_mask = fd922_genlock_sync_irq_mask,
+	.genlock_sync_irq_info = fd922_genlock_sync_irq_info,
+	.genlock_sync_offset = fd922_genlock_sync_offset,
+	.genlock_sync_output = fd922_genlock_sync_output,
 };
diff --git a/forward-v4l2/forward-v4l2-genlock.c b/forward-v4l2/forward-v4l2-genlock.c
index 83ef2d1..320d8a8 100644
--- a/forward-v4l2/forward-v4l2-genlock.c
+++ b/forward-v4l2/forward-v4l2-genlock.c
@@ -35,7 +35,8 @@ static void forward_v4l2_genlock_irq(void *priv, u32 irq, u64 timestamp)
 	spin_lock_irqsave(&gl->lock, sflags);
 	if (!field) {
 		if (gl->state == V4L_FORWARD_GENLOCK_LOCKING) {
-			if (gl->ref_offset == offset)
+			int delta = (int)gl->ref_offset - (int)offset;
+			if (abs(delta) <= 1)
 				gl->stable_ref_count++;
 			else
 				gl->stable_ref_count = 0;
diff --git a/forward/forward-fd922.c b/forward/forward-fd922.c
index f991803..9722575 100644
--- a/forward/forward-fd922.c
+++ b/forward/forward-fd922.c
@@ -86,13 +86,6 @@ static int fd922_init(struct forward_dev *dev)
 	dev->spi_xfer = &fd922_spi_xfer;
 
 	forward_si534x_init(dev, &dev->pll, 4, 3);
-	mode = dev->pll->ops->find_mode(dev->pll, 0, 0, 148500000, false);
-	if (mode) {
-		printk("TEST SWITCH\n");
-		dev->pll->ops->switch_mode(dev->pll, mode);
-		dev->pll->ops->select_input(dev->pll, 0, true, false);
-		dev->pll->ops->calibrate(dev->pll);
-	}
 
 	return 0;
 }
diff --git a/forward/forward-si532x.c b/forward/forward-si532x.c
index 385a2ac..07f1c98 100644
--- a/forward/forward-si532x.c
+++ b/forward/forward-si532x.c
@@ -167,16 +167,16 @@ static int si532x_load_defaults(struct forward_si532x *si532x)
 	return 0;
 }
 
-static struct forward_pll_mode *si532x_find_mode(struct forward_pll *pll, s64 in_freq,
-						 s64 common_in_freq, s64 out_freq, bool m)
+static struct forward_pll_mode *si532x_find_mode(struct forward_pll *pll, s64 in_pix_freq,
+						 s64 in_h_freq, bool in_m, s64 out_freq, bool out_m)
 {
 	int i;
 
 	if (out_freq != 148500000)
 		return NULL;
 
-	if (in_freq <= 0) {
-		if (!m)
+	if ((in_pix_freq <= 0) && (in_h_freq <= 0)) {
+		if (!in_m)
 			return (struct forward_pll_mode *)&si532x_default_mode;
 		else
 			return (struct forward_pll_mode *)&si532x_default_mode_m;
@@ -184,7 +184,8 @@ static struct forward_pll_mode *si532x_find_mode(struct forward_pll *pll, s64 in
 
 	for (i = 0; i < forward_si532x_modes_count; i++) {
 		const struct forward_si532x_mode *cur = &forward_si532x_modes[i];
-		if ((cur->in_freq == in_freq) && (cur->m == m)) {
+		if (((in_h_freq <= 0) || (cur->in_freq == in_h_freq)) &&
+		    ((in_pix_freq <= 0) || (cur->in_freq == in_pix_freq)) && (cur->m == in_m)) {
 			return (struct forward_pll_mode *)cur;
 		}
 	}
diff --git a/forward/forward-si534x.c b/forward/forward-si534x.c
index 086e2b3..c56f3b3 100644
--- a/forward/forward-si534x.c
+++ b/forward/forward-si534x.c
@@ -29,9 +29,10 @@ struct forward_si534x {
 };
 
 struct forward_si534x_mode {
-	int in_freq;
-	int pfd_freq;
-	bool m;
+	int in_freq_p;
+	int in_freq_h;
+	bool in_m;
+	bool out_m;
 	u64 Pn[3];
 	u32 Pd[3];
 	u64 Mn;
@@ -44,40 +45,390 @@ struct forward_si534x_mode {
 	u32 hold_15m_cyc_count;
 	u16 pfd_en_delay;
 };
-/*
-const struct forward_si532x_mode forward_si532x_modes[] = {
-	{ 13500000 / 200, false, 5, 9, 4, 11, 7200, 1, 400 },
-	{ 13500000 / 200, true, 3, 9, 4, 11, 36000, 5, 2002 },
-	{ 13500000 / 240, false, 5, 9, 4, 11, 8640, 1, 480 },
-	{ 13500000 / 400, false, 5, 9, 4, 11, 14400, 1, 800 },
-	{ 13500000 / 400, true, 2, 9, 4, 11, 72000, 5, 4004 },
-	{ 13500000 / 480, false, 4, 9, 4, 11, 17280, 1, 960 },
-	{ 13500000 / 500, false, 4, 9, 4, 11, 18000, 1, 1000 },
-	{ 13500000 / 500, true, 4, 9, 4, 11, 18000, 1, 1001 },
-	{ 13500000 / 400, false, 5, 9, 4, 11, 14400, 1, 800 },
-	{ 13500000 / 400, true, 2, 9, 4, 11, 72000, 5, 4004 },
-	{ 13500000 / 480, false, 4, 9, 4, 11, 17280, 1, 960 },
-	{ 13500000 / 300, false, 5, 9, 4, 11, 10800, 1, 600 },
-	{ 13500000 / 300, true, 3, 9, 4, 11, 54000, 5, 3003 },
-	{ 13500000 / 360, false, 5, 9, 4, 11, 12960, 1, 720 },
-	{ 13500000 / 600, false, 4, 9, 4, 11, 21600, 1, 1200 },
-	{ 13500000 / 600, true, 2, 9, 4, 11, 108000, 5, 6006 },
-	{ 13500000 / 720, false, 4, 9, 4, 11, 25920, 1, 1440 },
-	{ 13500000 / 750, false, 4, 9, 4, 11, 27000, 1, 1500 },
-	{ 13500000 / 750, true, 3, 9, 4, 11, 54000, 2, 3003 },
-	{ 13500000 / 864, false, 3, 9, 4, 11, 31104, 1, 1728 },
-	{ 13500000 / 858, false, 3, 9, 4, 11, 30888, 1, 1716 },
-	{ 13500000 / 858, false, 3, 9, 4, 11, 30888, 1, 1716 },
-	{ 6750000, false, 10, 9, 4, 11, 288, 4, 16 },
-	{ 74250000, false, 10, 9, 4, 11, 288, 44, 16 },
-	{ 74250000, true, 8, 9, 4, 10, 1800, 250, 91 },
-	{ 148500000, false, 10, 9, 4, 11, 252, 77, 14 },
-	{ 148500000, true, 8, 9, 4, 10, 1800, 500, 91 },
+
+const struct forward_si534x_mode forward_si534x_modes[] = {
+	{ 13500000,
+	  15625,
+	  false,
+	  false,
+	  { 1, 864, 864 },
+	  { 1, 1, 1 },
+	  0x014E2000000000,
+	  0x80000000,
+	  0x03070F0F170F,
+	  0x0307090A2B18,
+	  { 0, 10, 10 },
+	  { 0x12F684C, 0x1000000, 0x1000000 },
+	  0x00018AC7,
+	  0x01A0AB,
+	  0x06AC },
+	{ 13500000,
+	  15734,
+	  false,
+	  false,
+	  { 1, 858, 858 },
+	  { 1, 1, 1 },
+	  0x014BCE00000000,
+	  0x80000000,
+	  0x03070F0F170F,
+	  0x0307090A2B18,
+	  { 0, 10, 10 },
+	  { 0x1318776, 0x1000000, 0x1000000 },
+	  0x0000C942,
+	  0x019DC6,
+	  0x06A0 },
+	// 720p24
+	{ 74250000,
+	  18000,
+	  false,
+	  false,
+	  { 1, 4125, 4125 },
+	  { 1, 1, 1 },
+	  0x01220A00000000,
+	  0x80000000,
+	  0x07070F0F1810,
+	  0x0707090A2C19,
+	  { 0, 12, 12 },
+	  { 0x15D867C, 0x1600000, 0x1600000 },
+	  0x0000AF6C,
+	  0x0169B1,
+	  0x05C9 },
+	// 720p23.97
+	{ 74250000,
+	  18000,
+	  true,
+	  false,
+	  { 1, 4125, 4125 },
+	  { 1, 1, 1 },
+	  0x016AE950000000,
+	  0xA0000000,
+	  0x07070F0F1810,
+	  0x0707090A2C19,
+	  { 0, 12, 12 },
+	  { 0x15D2D19, 0x15FA5FA, 0x15FA5FA },
+	  0x0000AF9A,
+	  0x016A0E,
+	  0x05CB },
+	{ 74250000,
+	  18000,
+	  true,
+	  true,
+	  { 1, 4125, 4125 },
+	  { 1, 1, 1 },
+	  0x016AE950000000,
+	  0xA0000000,
+	  0x07070F0F1810,
+	  0x0707090A2C19,
+	  { 0, 12, 12 },
+	  { 0x15D2D19, 0x15FA5FA, 0x15FA5FA },
+	  0x0000AF9A,
+	  0x016A0E,
+	  0x05CB },
+	// 720p25
+	{ 74250000,
+	  18750,
+	  false,
+	  false,
+	  { 1, 3960, 3960 },
+	  { 1, 1, 1 },
+	  0x01167000000000,
+	  0x80000000,
+	  0x07070F0F1810,
+	  0x0707090A2C19,
+	  { 0, 12, 12 },
+	  { 0x16C16C1, 0x1600000, 0x1600000 },
+	  0x0000A83F,
+	  0x015B39,
+	  0x058F },
+	// 720p50
+	{ 74250000,
+	  37500,
+	  false,
+	  false,
+	  { 2, 3960, 3960 },
+	  { 1, 1, 1 },
+	  0x01167000000000,
+	  0x80000000,
+	  0x07070F0F1810,
+	  0x0707090A2C19,
+	  { 1, 12, 12 },
+	  { 0x16C16C1, 0x1600000, 0x1600000 },
+	  0x0000A83F,
+	  0x015B39,
+	  0x058F },
+	// 720p30
+	{ 74250000,
+	  22500,
+	  false,
+	  false,
+	  { 1, 3300, 3300 },
+	  { 1, 1, 1 },
+	  0x00E80800000000,
+	  0x80000000,
+	  0x07070E0E1910,
+	  0x070708092D19,
+	  { 0, 12, 12 },
+	  { 0x1B4E81B, 0x1600000, 0x1600000 },
+	  0x00008B89,
+	  0x01215B,
+	  0x04A1 },
+	// 720p60
+	{ 74250000,
+	  45000,
+	  false,
+	  false,
+	  { 2, 3300, 3300 },
+	  { 1, 1, 1 },
+	  0x00E80800000000,
+	  0x80000000,
+	  0x07070E0E1910,
+	  0x070708092D19,
+	  { 1, 12, 12 },
+	  { 0x1B4E81B, 0x1600000, 0x1600000 },
+	  0x00008B89,
+	  0x01215B,
+	  0x04A1 },
+	// 720p29.97
+	{ 74250000,
+	  22500,
+	  true,
+	  false,
+	  { 1, 3300, 3300 },
+	  { 1, 1, 1 },
+	  0x01225440000000,
+	  0xA0000000,
+	  0x07070E0E1910,
+	  0x070708092D19,
+	  { 0, 12, 12 },
+	  { 0x1B4785F, 0x15FA5FA, 0x15FA5FA },
+	  0x00008BAE,
+	  0x0121A5,
+	  0x04A2 },
+	{ 74250000,
+	  22500,
+	  true,
+	  true,
+	  { 1, 3300, 3300 },
+	  { 1, 1, 1 },
+	  0x01225440000000,
+	  0xA0000000,
+	  0x07070E0E1910,
+	  0x070708092D19,
+	  { 0, 12, 12 },
+	  { 0x1B4785F, 0x15FA5FA, 0x15FA5FA },
+	  0x00008BAE,
+	  0x0121A5,
+	  0x04A2 },
+	// 720p59.94
+	{ 74250000,
+	  22500,
+	  true,
+	  false,
+	  { 2, 3300, 3300 },
+	  { 1, 1, 1 },
+	  0x01225440000000,
+	  0xA0000000,
+	  0x07070E0E1910,
+	  0x070708092D19,
+	  { 1, 12, 12 },
+	  { 0x1B4785F, 0x15FA5FA, 0x15FA5FA },
+	  0x00008BAE,
+	  0x0121A5,
+	  0x04A2 },
+	{ 74250000,
+	  22500,
+	  true,
+	  true,
+	  { 2, 3300, 3300 },
+	  { 1, 1, 1 },
+	  0x01225440000000,
+	  0xA0000000,
+	  0x07070E0E1910,
+	  0x070708092D19,
+	  { 1, 12, 12 },
+	  { 0x1B4785F, 0x15FA5FA, 0x15FA5FA },
+	  0x00008BAE,
+	  0x0121A5,
+	  0x04A2 },
+	// 1080p24
+	{ 74250000,
+	  27000,
+	  false,
+	  false,
+	  { 1, 2750, 2750 },
+	  { 1, 1, 1 },
+	  0x00C15C00000000,
+	  0x80000000,
+	  0x07070F0F170F,
+	  0x0707090A2B18,
+	  { 1, 12, 12 },
+	  { 0x10624DD, 0x1600000, 0x1600000 },
+	  0x0000EB3E,
+	  0x00F121,
+	  0x03DB },
+	// 1080p23.98
+	{ 74250000,
+	  27000,
+	  true,
+	  false,
+	  { 1, 2750, 2750 },
+	  { 1, 1, 1 },
+	  0x00C18D80000000,
+	  0x80000000,
+	  0x07070F0F170F,
+	  0x0707090A2B18,
+	  { 1, 12, 12 },
+	  { 0x105E1D2, 0x15FA5FA, 0x15FA5FA },
+	  0x0000EB7C,
+	  0x00F15F,
+	  0x03DC },
+	{ 74250000,
+	  27000,
+	  true,
+	  true,
+	  { 1, 2750, 2750 },
+	  { 1, 1, 1 },
+	  0x00C18D80000000,
+	  0x80000000,
+	  0x07070F0F170F,
+	  0x0707090A2B18,
+	  { 1, 12, 12 },
+	  { 0x105E1D2, 0x15FA5FA, 0x15FA5FA },
+	  0x0000EB7C,
+	  0x00F15F,
+	  0x03DC },
+	// 1080p25/i50
+	{ 74250000,
+	  28125,
+	  false,
+	  false,
+	  { 1, 2640, 2640 },
+	  { 1, 1, 1 },
+	  0x00B9A000000000,
+	  0x80000000,
+	  0x07070F0F170F,
+	  0x0707090A2B18,
+	  { 1, 12, 12 },
+	  { 0x1111111, 0x1600000, 0x1600000 },
+	  0x0000E1AD,
+	  0x00E77C,
+	  0x03B3 },
+	// 1080p50
+	{ 148500000,
+	  56250,
+	  false,
+	  false,
+	  { 2, 5280, 5280 },
+	  { 1, 1, 1 },
+	  0x00B9A000000000,
+	  0x80000000,
+	  0x07070F0F170F,
+	  0x0707090A2B18,
+	  { 2, 13, 13 },
+	  { 0x1111111, 0x1600000, 0x1600000 },
+	  0x0000E1AD,
+	  0x00E77C,
+	  0x03B3 },
+	// 1080p30/i60
+	{ 74250000,
+	  33750,
+	  false,
+	  false,
+	  { 1, 2200, 2200 },
+	  { 1, 1, 1 },
+	  0x009AB000000000,
+	  0x80000000,
+	  0x07030F0F1810,
+	  0x070308092E1A,
+	  { 1, 12, 12 },
+	  { 0x147AE14, 0x1600000, 0x1600000 },
+	  0x0000BB65,
+	  0x00C0E7,
+	  0x0315 },
+	// 1080p60
+	{ 148500000,
+	  67500,
+	  false,
+	  false,
+	  { 2, 4400, 4400 },
+	  { 1, 1, 1 },
+	  0x009AB000000000,
+	  0x80000000,
+	  0x07030F0F1810,
+	  0x070308092E1A,
+	  { 2, 13, 13 },
+	  { 0x147AE14, 0x1600000, 0x1600000 },
+	  0x0000BB65,
+	  0x00C0E7,
+	  0x0315 },
+	// 1080p29.97/i59.94
+	{ 74250000,
+	  33750,
+	  true,
+	  false,
+	  { 1, 2200, 2200 },
+	  { 1, 1, 1 },
+	  0x00C18D80000000,
+	  0xA0000000,
+	  0x07030F0F1810,
+	  0x070308092E1A,
+	  { 1, 12, 12 },
+	  { 0x1475A47, 0x15FA5FA, 0x15FA5FA },
+	  0x0000BB96,
+	  0x00C119,
+	  0x0316 },
+	{ 74250000,
+	  33750,
+	  true,
+	  true,
+	  { 1, 2200, 2200 },
+	  { 1, 1, 1 },
+	  0x00C18D80000000,
+	  0xA0000000,
+	  0x07030F0F1810,
+	  0x070308092E1A,
+	  { 1, 12, 12 },
+	  { 0x1475A47, 0x15FA5FA, 0x15FA5FA },
+	  0x0000BB96,
+	  0x00C119,
+	  0x0316 },
+	// 1080p59.94
+	{ 148500000,
+	  67500,
+	  true,
+	  false,
+	  { 2, 4400, 4400 },
+	  { 1, 1, 1 },
+	  0x00C18D80000000,
+	  0xA0000000,
+	  0x07030F0F1810,
+	  0x070308092E1A,
+	  { 2, 13, 13 },
+	  { 0x1475A47, 0x15FA5FA, 0x15FA5FA },
+	  0x0000BB96,
+	  0x00C119,
+	  0x0316 },
+	{ 148500000,
+	  67500,
+	  true,
+	  true,
+	  { 2, 4400, 4400 },
+	  { 1, 1, 1 },
+	  0x00C18D80000000,
+	  0xA0000000,
+	  0x07030F0F1810,
+	  0x070308092E1A,
+	  { 2, 13, 13 },
+	  { 0x1475A47, 0x15FA5FA, 0x15FA5FA },
+	  0x0000BB96,
+	  0x00C119,
+	  0x0316 },
 };
-*/
+
 const struct forward_si534x_mode si534x_default_mode = { -1,
 							 -1,
 							 false,
+							 false,
 							 { 1, 2640, 2640 },
 							 { 1, 1, 1 },
 							 0x00B9A000000000,
@@ -89,106 +440,40 @@ const struct forward_si534x_mode si534x_default_mode = { -1,
 							 0x0000E1AD,
 							 0x00E77C,
 							 0x03B3 };
+const struct forward_si534x_mode si534x_default_mode_m = { -1,
+							   -1,
+							   true,
+							   false,
+							   { 1, 2200, 2200 },
+							   { 1, 1, 1 },
+							   0x00C18D80000000,
+							   0xA0000000,
+							   0x07030F0F1810,
+							   0x070308092E1A,
+							   { 1, 12, 12 },
+							   { 0x1475A47, 0x15FA5FA, 0x15FA5FA },
+							   0x0000BB96,
+							   0x00C119,
+							   0x0316 };
+
+const struct forward_si534x_mode si534x_default_mode_m_m = { -1,
+							     -1,
+							     true,
+							     true,
+							     { 1, 2200, 2200 },
+							     { 1, 1, 1 },
+							     0x00C18D80000000,
+							     0xA0000000,
+							     0x07030F0F1810,
+							     0x070308092E1A,
+							     { 1, 12, 12 },
+							     { 0x1475A47, 0x15FA5FA, 0x15FA5FA },
+							     0x0000BB96,
+							     0x00C119,
+							     0x0316 };
+const int forward_si534x_modes_count =
+	sizeof(forward_si534x_modes) / sizeof(struct forward_si534x_mode);
 
-/*
-const int forward_si532x_modes_count =
-	sizeof(forward_si532x_modes) / sizeof(struct forward_si532x_mode);
-*/
-
-/*static int si532x_write_reg(struct forward_si532x *si532x, u8 reg, u8 data)
-{
-	return si532x->pll.dev->i2c_xfer(si532x->pll.dev, si532x->bus, false, si532x->address, reg,
-					 &data);
-}
-
-static int si532x_read_reg(struct forward_si532x *si532x, u8 reg, u8 *data)
-{
-	return si532x->pll.dev->i2c_xfer(si532x->pll.dev, si532x->bus, true, si532x->address, reg,
-					 data);
-}*/
-
-/*
-static int si532x_configure_factors(struct forward_si532x *si532x, u8 bwsel, u8 n1_hs, u32 nc1_ls,
-				    u8 n2_hs, u32 n2_ls, u32 n31, u32 n32)
-{
-	u32 reg_value;
-
-	if (bwsel > 15)
-		return -EINVAL;
-
-	if (n1_hs < 4 || n1_hs > 11)
-		return -EINVAL;
-
-	if (((nc1_ls != 1) && (nc1_ls % 2)) || (nc1_ls < 1) || (nc1_ls > (1 << 20)))
-		return -EINVAL;
-
-	if (n2_hs < 4 || n2_hs > 11)
-		return -EINVAL;
-
-	if (((n2_ls != 1) && (n2_ls % 2)) || (n2_ls < 1) || (n2_ls > (1 << 20)))
-		return -EINVAL;
-
-	if ((n31 < 1) || (n31 > (1 << 19)))
-		return -EINVAL;
-
-	if ((n32 < 1) || (n32 > (1 << 19)))
-		return -EINVAL;
-
-	si532x_write_reg(si532x, 0x02, (bwsel << 4) | (0x2));
-	si532x_write_reg(si532x, 0x19, ((n1_hs - 4) << 5));
-
-	reg_value = nc1_ls - 1;
-	si532x_write_reg(si532x, 0x1F, (reg_value >> 16) & 0x0F);
-	si532x_write_reg(si532x, 0x20, (reg_value >> 8) & 0xFF);
-	si532x_write_reg(si532x, 0x21, reg_value & 0xFF);
-
-	reg_value = n2_ls - 1;
-	si532x_write_reg(si532x, 0x28, ((n2_hs - 4) << 5) | ((reg_value >> 16) & 0x0F));
-	si532x_write_reg(si532x, 0x29, (reg_value >> 8) & 0xFF);
-	si532x_write_reg(si532x, 0x2A, reg_value & 0xFF);
-
-	reg_value = n31 - 1;
-	si532x_write_reg(si532x, 0x2B, (reg_value >> 16) & 0x07);
-	si532x_write_reg(si532x, 0x2C, (reg_value >> 8) & 0xFF);
-	si532x_write_reg(si532x, 0x2D, reg_value & 0xFF);
-
-	reg_value = n32 - 1;
-	si532x_write_reg(si532x, 0x2E, (reg_value >> 16) & 0x07);
-	si532x_write_reg(si532x, 0x2F, (reg_value >> 8) & 0xFF);
-	si532x_write_reg(si532x, 0x30, reg_value & 0xFF);
-
-	return 0;
-}
-*/
-/*
-static int si532x_load_defaults(struct forward_si532x *si532x)
-{
-	// PLL mode, CLK always on, no bypass
-	si532x_write_reg(si532x, 0x00, 0x34);
-	// CLKIN1 > CLKIN2 priority
-	//si532x_write_reg(si532x, 0x01, 0xE1);
-	// No output disabling during calibration, CLKIN2 selected
-	si532x_write_reg(si532x, 0x03, 0x55);
-	// Automatic clock selection, default hold history
-	//si532x_write_reg(si532x, 0x04, 0x92);
-	// LVDS outputs
-	si532x_write_reg(si532x, 0x06, 0x0F);
-	// External crystal as reference
-	si532x_write_reg(si532x, 0x07, 0x28);
-	// CLKOUT1 enabled, CLKOUT2 disabled
-	si532x_write_reg(si532x, 0x0A, 0x08);
-	// Frequency offset and phase error detector
-	si532x_write_reg(si532x, 0x13, 0x2F);
-	// Enable CK2_BAD, LOL, INT pins
-	si532x_write_reg(si532x, 0x14, 0x3B);
-	// Disable clock selection pins
-	si532x_write_reg(si532x, 0x15, 0xFC);
-	// Enable fast lock
-	si532x_write_reg(si532x, 0x89, 0x01);
-
-	return 0;
-}
-*/
 inline void si534x_select_bank(struct forward_si534x *si534x, u16 addr)
 {
 	u8 bank = ((addr >> 8) & 0xFF);
@@ -295,27 +580,32 @@ static void si534x_write_reg_56(struct forward_si534x *si534x, u16 addr, u64 dat
 //	si534x_read_data(si534x, addr, (u8*)data, 7);
 //}
 
-static struct forward_pll_mode *si534x_find_mode(struct forward_pll *pll, s64 in_freq,
-						 s64 common_in_freq, s64 out_freq, bool m)
+static struct forward_pll_mode *si534x_find_mode(struct forward_pll *pll, s64 in_pix_freq,
+						 s64 in_h_freq, bool in_m, s64 out_freq, bool out_m)
 {
 	int i;
 
 	if (out_freq != 148500000)
 		return NULL;
 
-	if (in_freq <= 0) {
-		//if (!m)
-		return (struct forward_pll_mode *)&si534x_default_mode;
-		//else
-		//	return (struct forward_pll_mode *)&si532x_default_mode_m;
+	if ((in_pix_freq <= 0) && (in_h_freq <= 0)) {
+		if (!in_m)
+			return (struct forward_pll_mode *)&si534x_default_mode;
+		else if (!out_m)
+			return (struct forward_pll_mode *)&si534x_default_mode_m;
+		else
+			return (struct forward_pll_mode *)&si534x_default_mode_m_m;
 	}
 
-	/*for (i = 0; i < forward_si532x_modes_count; i++) {
-		const struct forward_si532x_mode *cur = &forward_si532x_modes[i];
-		if ((cur->in_freq == in_freq) && (cur->m == m)) {
+	for (i = 0; i < forward_si534x_modes_count; i++) {
+		const struct forward_si534x_mode *cur = &forward_si534x_modes[i];
+		if (((in_pix_freq < 0) || (cur->in_freq_p == in_pix_freq)) &&
+		    ((in_h_freq < 0) || (cur->in_freq_h == in_h_freq)) && (cur->in_m == in_m) &&
+		    (cur->out_m == out_m)) {
 			return (struct forward_pll_mode *)cur;
 		}
-	}*/
+	}
+
 	return NULL;
 }
 
@@ -326,7 +616,7 @@ static int si534x_switch_mode(struct forward_pll *pll, struct forward_pll_mode *
 
 	si534x_write_reg_8(si534x, 0x0B24, 0xC0);
 	si534x_write_reg_8(si534x, 0x0B25, 0x00);
-	si534x_write_reg_8(si534x, 0x0B40, 0x01);
+	si534x_write_reg_8(si534x, 0x0540, 0x01);
 
 	msleep(300);
 
@@ -349,18 +639,35 @@ static int si534x_switch_mode(struct forward_pll *pll, struct forward_pll_mode *
 
 	si534x_write_reg_48(si534x, 0x0508, m->Bslow);
 	si534x_write_reg_48(si534x, 0x050E, m->Bfast);
+	si534x_write_reg_8(si534x, 0x0514, 0x01);
 
 	si534x_write_reg_56(si534x, 0x0515, m->Mn);
 	si534x_write_reg_32(si534x, 0x051C, m->Md);
-	si534x_write_reg_32(si534x, 0x0520, 0x1);
+	si534x_write_reg_8(si534x, 0x0520, 0x1);
 
 	si534x_write_reg_24(si534x, 0x0532, m->hold_15m_cyc_count);
 	si534x_write_reg_16(si534x, 0x0589, m->pfd_en_delay);
 
+	//si534x_write_reg_24(si534x, 0x0250, 0x00);
+	//si534x_write_reg_24(si534x, 0x0253, 0x00);
+
+	if (m->out_m) {
+		si534x_write_reg_48(si534x, 0x0302, 0x2331000000ULL);
+		si534x_write_reg_32(si534x, 0x0308, 0xc8000000);
+		si534x_write_reg_8(si534x, 0x030c, 0x1);
+	} else {
+		si534x_write_reg_48(si534x, 0x0302, 0x2328000000ULL);
+		si534x_write_reg_32(si534x, 0x0308, 0xc8000000);
+		si534x_write_reg_8(si534x, 0x030c, 0x1);
+	}
+	si534x_write_reg_48(si534x, 0x030d, 0x2331000000ULL);
+	si534x_write_reg_32(si534x, 0x0313, 0xc8000000);
+	si534x_write_reg_8(si534x, 0x0317, 0x1);
+
 	si534x_write_reg_8(si534x, 0x001C, 0x01);
-	si534x_write_reg_8(si534x, 0x0B40, 0x00);
+	si534x_write_reg_8(si534x, 0x0540, 0x00);
 	si534x_write_reg_8(si534x, 0x0B24, 0xC3);
-	si534x_write_reg_8(si534x, 0x0B25, 0xC2);
+	si534x_write_reg_8(si534x, 0x0B25, 0x02);
 
 	return 0;
 }
@@ -397,11 +704,7 @@ static int si534x_tune(struct forward_pll *pll, s64 ppt)
 	struct forward_si534x *si534x = container_of(pll, struct forward_si534x, pll);
 	u32 denom = 0xc8000000 + 0xc8000000LL * ppt / 1000000000000LL;
 
-	printk("si534x_tune(): %llu/%llu\n", 0x2328000000ULL, denom);
-
-	si534x_write_reg_48(si534x, 0x302, 0x2328000000ULL);
 	si534x_write_reg_32(si534x, 0x308, denom);
-	si534x_write_reg_48(si534x, 0x30d, 0x2331000000ULL);
 	si534x_write_reg_32(si534x, 0x313, denom);
 	si534x_write_reg_32(si534x, 0x338, 2);
 
diff --git a/include/forward-pll.h b/include/forward-pll.h
index a23d080..683f8f9 100644
--- a/include/forward-pll.h
+++ b/include/forward-pll.h
@@ -33,8 +33,8 @@ struct forward_pll;
 #define FORWARD_PLL_FEATURE_TUNE (1 << 2)
 
 struct forward_pll_ops {
-	struct forward_pll_mode *(*find_mode)(struct forward_pll *pll, s64 in_freq,
-					      s64 common_in_freq, s64 out_freq, bool m);
+	struct forward_pll_mode *(*find_mode)(struct forward_pll *pll, s64 in_pix_freq,
+					      s64 in_h_freq, bool in_m, s64 out_freq, bool out_m);
 	int (*switch_mode)(struct forward_pll *pll, struct forward_pll_mode *mode);
 	int (*select_input)(struct forward_pll *pll, int input, bool master, bool autoswitch);
 	int (*tune)(struct forward_pll *pll, s64 ppt);
-- 
2.39.1


